/************************************/
/*    qQœK@vO      */
/*            pso.c                 */
/*                                  */
/************************************/

#include <stdio.h>
#include <stdlib.h>

/*   L萔                      */
#define NOPS 10 /*q̌*/
#define LIMITL 256 /*ző̈*/
#define ILIMIT 100 /*JԂ̉*/
#define SEED 32767 /*̏l*/
#define W 0.7 /*萔*/
#define C1 1.4 /*[JȎ*/
#define C2 1.4 /*O[oȎ*/

/*  ʍW\\        */
struct point{
 double x ;
 double y ;
} ;

/*     q\\        */
struct particle{
 struct point pos ;/*ʒu*/
 double value ;/*]l*/
 struct point v ;/*x*/
 struct point bestpos ;/*œKʒu*/
 double bestval ;/*œK]l*/
} ;


/*   ֐̃vg^Cv̐錾      */
void initps(struct particle ps[]) ;
                   /*qQ̏*/
void printps(struct particle ps[]) ;
                    /*qQ̕\*/
double frand() ;/**/
double calcval(double x,double y) ;/*]ľvZ*/
void optimize(struct particle ps[]) ;
                  /*qQ̈ʒuXV*/
void setgbest(struct particle ps[]) ;
         /*  Q̍œKʒui[  */

/*ϐ*/
struct point gbestpos ;/*Q̍œKʒu*/
double gbestval ;/*Q̍œK]l*/


/**********************/
/*     main()֐     */
/**********************/
int main()
{
 struct particle ps[LIMITL] ;/*qQ*/
 int i;/*JԂ񐔂̐*/
 
 /*̏*/
 srand(SEED) ;

 /*qQ̏*/
 initps(ps) ;
 printps(ps) ;

 /*œK̖{*/
 for(i=0;i<ILIMIT;++i){
  optimize(ps) ;
  printf("%d\n",i) ;
  printps(ps) ;
 }

 return 0 ;
}

/**************************/
/*    optimize()֐      */
/*    qQ̈ʒuXV    */
/**************************/
void optimize(struct particle ps[])
{
 int i ;
 double r1,r2 ;/*̒li[*/

 for(i=0;i<NOPS;++i){
  /*̐ݒ*/
  r1=frand() ;
  r2=frand() ;  
  /*x̍XV*/
  ps[i].v.x=W*ps[i].v.x
     +C1*r1*(ps[i].bestpos.x-ps[i].pos.x)
     +C2*r2*(gbestpos.x-ps[i].pos.x) ;

  ps[i].v.y=W*ps[i].v.y
     +C1*r1*(ps[i].bestpos.y-ps[i].pos.y)
     +C2*r2*(gbestpos.y-ps[i].pos.y) ;

  /*ʒu̍XV*/
  ps[i].pos.x+=ps[i].v.x ;
  ps[i].pos.y+=ps[i].v.y ;

  /*œKl̍XV*/
  ps[i].value=calcval(ps[i].pos.x,ps[i].pos.y) ;
  if(ps[i].value<ps[i].bestval){
   ps[i].bestval=ps[i].value ;
   ps[i].bestpos=ps[i].pos ;
  }
 }
  /*QœKl̍XV*/
 setgbest(ps) ;
}


/**************************/
/*    calcbal()֐       */
/*    ]ľvZ        */
/**************************/
double calcval(double x,double y)
{
 return x*x+y*y+1 ;
}

/**************************/
/*    setgbest()֐      */
/*  Q̍œKʒui[  */
/**************************/
void setgbest(struct particle ps[])
{
 int i ;
 double besti ;
 double x,y ;

 besti=ps[0].value ;
 x=ps[0].pos.x ;
 y=ps[0].pos.y ;

 for(i=0;i<NOPS;++i)
  /*݂̍ŗǕ]lT*/
  if(ps[i].value<besti){
   besti=ps[i].value ;
   x=ps[i].pos.x ;
   y=ps[i].pos.y ;
  }

 /*]lߋ悩XV*/
 if(besti<gbestval){
  gbestval=besti ;
  gbestpos.x=x ;
  gbestpos.y=y ;
 }
}

/**************************/
/*    initps()֐        */
/*    qQ̏      */
/**************************/
void initps(struct particle ps[])
{
 int i ;
 double x,y ;

 for(i=0;i<NOPS;++i){
  /*ʒu*/
  x=ps[i].pos.x=frand()*2-1.0 ;
  y=ps[i].pos.y=frand()*2-1.0 ;
  /*]l*/
  ps[i].value=calcval(x,y) ;
  /*x*/
  ps[i].v.x=frand()*2-1.0 ;
  ps[i].v.y=frand()*2-1.0 ;
  /*œKʒu*/
  ps[i].bestpos.x=ps[i].pos.x ;
  ps[i].bestpos.y=ps[i].pos.y ;
  /*œK]l*/
  ps[i].bestval=ps[i].value ;
 }
 /*Q̍œKʒui[*/
 gbestval=ps[0].value ;
 gbestpos.x=ps[0].pos.x ;
 gbestpos.y=ps[0].pos.y ;
 setgbest(ps) ;
}


/**************************/
/*   printps()֐        */
/*    qQ̕\        */
/**************************/
void printps(struct particle ps[])
{
 int i ;

 for(i=0;i<NOPS;++i){
  printf("%d ",i);
  printf("%lf %lf ",ps[i].pos.x,ps[i].pos.y) ;
  printf("%lf ",ps[i].value) ;
  printf("%lf %lf ",ps[i].v.x,ps[i].v.y) ;
  printf("%lf %lf ",
       ps[i].bestpos.x,ps[i].bestpos.y) ;
  printf("%lf\n",ps[i].bestval) ;
 }
 printf("%lf %lf %lf\n",gbestpos.x,gbestpos.y,gbestval) ;
}

/*************************/
/*   frand()֐         */
/*               */
/*************************/
double frand(void)
{
 double result ;
 while((result=(double)rand()/RAND_MAX)>=1) ;
 return result ;
}

